/* $Id: flow.h,v 1.5 2002/07/24 10:10:20 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef FLOW_H
#define FLOW_H

typedef void *flow_handle_t;
typedef int flow_pos_t;

typedef struct flow_class
{ 
	char *name;
	flow_handle_t (*open)(char *name, char *options, int writeable);
	void (*close)(flow_handle_t fh);
	int (*getc)(flow_handle_t fh);
	int (*ungetc)(flow_handle_t fh, int ch);
	int (*putc)(flow_handle_t fh, int ch);
	int (*puts)(flow_handle_t fh, char *str);
	flow_pos_t (*getpos)(flow_handle_t fh);
	int (*setpos)(flow_handle_t fh, flow_pos_t fp);
	int (*rewind)(flow_handle_t fh);
	char *(*flowctl)(flow_handle_t fh, char *ctl);
} flow_class;

flow_class *detect_flow_class(char *name, char **proper_name, char **options);
void register_new_flow(char *name, flow_class *fc);

#define FLOW_EOF (-1)
#define FLOW_ERROR (-2)

#endif

